## nodejs 0.1.97

=== Makefile ===
WAF=python tools/waf-light

all:
	echo $(WAF)
	@$(WAF) build

all-debug:
	@$(WAF) -v build

all-progress:
	@$(WAF) -p build

install:
	@$(WAF) install

uninstall:
	@$(WAF) uninstall

test: all
	python tools/test.py --mode=release simple

test-all: all
	python tools/test.py --mode=debug,release

test-release: all
	python tools/test.py --mode=release

test-debug: all
	python tools/test.py --mode=debug

test-simple: all
	python tools/test.py simple
     
test-pummel: all
	python tools/test.py pummel
	
test-internet: all
	python tools/test.py internet

benchmark: all
	build/default/node benchmark/run.js

# http://rtomayko.github.com/ronn
# gem install ronn
doc: doc/node.1 doc/api.html doc/index.html doc/changelog.html

## HACK to give the ronn-generated page a TOC
doc/api.html: doc/api.markdown doc/api_header.html doc/api_footer.html
	ronn -f --html doc/api.markdown \
	| sed "s/<h2>\(.*\)<\/h2>/<h2 id=\"\1\">\1<\/h2>/g" \
	| cat doc/api_header.html - doc/api_footer.html > doc/api.html

doc/changelog.html: ChangeLog doc/changelog_header.html doc/changelog_footer.html
	cat doc/changelog_header.html ChangeLog doc/changelog_footer.html > doc/changelog.html

doc/node.1: doc/api.markdown
	ronn --roff doc/api.markdown > doc/node.1

website-upload: doc
	scp doc/* ryan@nodejs.org:~/tinyclouds/node/

docclean:
	@-rm -f doc/node.1 doc/api.html doc/changelog.html

clean:
	@$(WAF) clean
	@-find tools -name "*.pyc" | xargs rm -f

distclean: docclean
	@-find tools -name "*.pyc" | xargs rm -f
	@-rm -rf build/ node node_g

check:
	@tools/waf-light check

VERSION=$(shell git describe)
TARNAME=node-$(VERSION)

dist: doc/node.1 doc/api.html
	git archive --format=tar --prefix=$(TARNAME)/ HEAD | tar xf -
	mkdir -p $(TARNAME)/doc
	cp doc/node.1 $(TARNAME)/doc/node.1
	cp doc/api.html $(TARNAME)/doc/api.html
	rm -rf $(TARNAME)/deps/v8/test # too big
	tar -cf $(TARNAME).tar $(TARNAME)
	rm -rf $(TARNAME)
	gzip -f -9 $(TARNAME).tar

.PHONY: benchmark clean docclean dist distclean check uninstall install all test test-all website-upload

=== wscript ===
#!/usr/bin/env python
import re
import Options
import sys, os, shutil
from Utils import cmd_output
from os.path import join, dirname, abspath
from logging import fatal

cwd = os.getcwd()
VERSION="0.1.97"
APPNAME="node.js"

import js2c

srcdir = '.'
blddir = 'build'


jobs=1
if os.environ.has_key('JOBS'):
  jobs = int(os.environ['JOBS'])

def set_options(opt):
  # the gcc module provides a --debug-level option
  opt.tool_options('compiler_cxx')
  opt.tool_options('compiler_cc')
  opt.tool_options('misc')
  opt.add_option( '--debug'
                , action='store_true'
                , default=False
                , help='Build debug variant [Default: False]'
                , dest='debug'
                )
  opt.add_option( '--efence'
                , action='store_true'
                , default=False
                , help='Build with -lefence for debugging [Default: False]'
                , dest='efence'
                )
  opt.add_option( '--system'
                , action='store_true'
                , default=False
                , help='Build using system libraries and headers (like a debian build) [Default: False]'
                , dest='system'
                )
  opt.add_option( '--without-ssl'
                , action='store_true'
                , default=False
                , help='Build without SSL'
                , dest='without_ssl'
                )

def configure(conf):
  conf.check_tool('compiler_cxx')
  if not conf.env.CXX: conf.fatal('c++ compiler not found')
  conf.check_tool('compiler_cc')
  if not conf.env.CC: conf.fatal('c compiler not found')

  conf.env["USE_DEBUG"] = Options.options.debug
  conf.env["USE_SYSTEM"] = Options.options.system

  conf.check(lib='dl', uselib_store='DL')
  if not sys.platform.startswith("sunos"):
    conf.env.append_value("CCFLAGS", "-rdynamic")
    conf.env.append_value("LINKFLAGS_DL", "-rdynamic")

  if sys.platform.startswith("freebsd"):
    conf.check(lib='kvm', uselib_store='KVM')

  #if Options.options.debug:
  #  conf.check(lib='profiler', uselib_store='PROFILER')

  if Options.options.efence:
    conf.check(lib='efence', libpath=['/usr/lib', '/usr/local/lib'], uselib_store='EFENCE')

  if not conf.check(lib="execinfo", includes=['/usr/include', '/usr/local/include'], libpath=['/usr/lib', '/usr/local/lib'], uselib_store="EXECINFO"):
    # Note on Darwin/OS X: This will fail, but will still be used as the
    # execinfo stuff are part of the standard library.
    if sys.platform.startswith("freebsd"):
      conf.fatal("Install the libexecinfo port from /usr/ports/devel/libexecinfo.")

  if not Options.options.without_ssl:
    if conf.check_cfg(package='openssl',
                      args='--cflags --libs',
                      uselib_store='OPENSSL'):
      conf.env["USE_OPENSSL"] = True
      conf.env.append_value("CXXFLAGS", "-DHAVE_OPENSSL=1")
    else:
      libssl = conf.check_cc(lib='ssl',
                             header_name='openssl/ssl.h',
                             function_name='SSL_library_init',
                             libpath=['/usr/lib', '/usr/local/lib', '/opt/local/lib', '/usr/sfw/lib'],
                             uselib_store='OPENSSL')
      libcrypto = conf.check_cc(lib='crypto',
                                header_name='openssl/crypto.h',
                                uselib_store='OPENSSL')
      if libcrypto and libssl:
        conf.env["USE_OPENSSL"] = True
        conf.env.append_value("CXXFLAGS", "-DHAVE_OPENSSL=1")

  conf.check(lib='rt', uselib_store='RT')

  if sys.platform.startswith("sunos"):
    if not conf.check(lib='socket', uselib_store="SOCKET"):
      conf.fatal("Cannot find socket library")
    if not conf.check(lib='nsl', uselib_store="NSL"):
      conf.fatal("Cannot find nsl library")

  conf.sub_config('deps/libeio')
  if not Options.options.system:
    conf.sub_config('deps/libev')
    conf.sub_config('deps/c-ares')
  else:
    if not conf.check(lib='v8', uselib_store='V8'):
      conf.fatal("Cannot find V8")
    if not conf.check(lib='ev', uselib_store='EV'):
      conf.fatal("Cannot find libev")
    if not conf.check(lib='cares', uselib_store='CARES'):
      conf.fatal("Cannot find c-ares")

  conf.define("HAVE_CONFIG_H", 1)

  if sys.platform.startswith("sunos"):
    conf.env.append_value ('CCFLAGS', '-threads')
    conf.env.append_value ('CXXFLAGS', '-threads')
    #conf.env.append_value ('LINKFLAGS', ' -threads')
  else:
    threadflags='-pthread'
    conf.env.append_value ('CCFLAGS', threadflags)
    conf.env.append_value ('CXXFLAGS', threadflags)
    conf.env.append_value ('LINKFLAGS', threadflags)

  conf.env.append_value("CCFLAGS", "-DX_STACKSIZE=%d" % (1024*64))

  # LFS
  conf.env.append_value('CCFLAGS',  '-D_LARGEFILE_SOURCE')
  conf.env.append_value('CXXFLAGS', '-D_LARGEFILE_SOURCE')
  conf.env.append_value('CCFLAGS',  '-D_FILE_OFFSET_BITS=64')
  conf.env.append_value('CXXFLAGS', '-D_FILE_OFFSET_BITS=64')

  ## needed for node_file.cc fdatasync
  ## Strangely on OSX 10.6 the g++ doesn't see fdatasync but gcc does?
  code =  """
    #include <unistd.h>
    int main(void)
    {
       int fd = 0;
       fdatasync (fd);
       return 0;
    }
  """
  if conf.check_cxx(msg="Checking for fdatasync(2) with c++", fragment=code):
    conf.env.append_value('CXXFLAGS', '-DHAVE_FDATASYNC=1')
  else:
    conf.env.append_value('CXXFLAGS', '-DHAVE_FDATASYNC=0')

  # platform
  platform_def = '-DPLATFORM=' + sys.platform
  conf.env.append_value('CCFLAGS', platform_def)
  conf.env.append_value('CXXFLAGS', platform_def)

  # Split off debug variant before adding variant specific defines
  debug_env = conf.env.copy()
  conf.set_env_name('debug', debug_env)

  # Configure debug variant
  conf.setenv('debug')
  debug_env.set_variant('debug')
  debug_env.append_value('CCFLAGS', ['-DDEBUG', '-g', '-O0', '-Wall', '-Wextra'])
  debug_env.append_value('CXXFLAGS', ['-DDEBUG', '-g', '-O0', '-Wall', '-Wextra'])
  conf.write_config_header("config.h")

  # Configure default variant
  conf.setenv('default')
  conf.env.append_value('CCFLAGS', ['-DNDEBUG', '-g', '-O3'])
  conf.env.append_value('CXXFLAGS', ['-DNDEBUG', '-g', '-O3'])
  conf.write_config_header("config.h")


def v8_cmd(bld, variant):
  scons = join(cwd, 'tools/scons/scons.py')
  deps_src = join(bld.path.abspath(),"deps")
  v8dir_src = join(deps_src,"v8")

  # NOTE: We want to compile V8 to export its symbols. I.E. Do not want
  # -fvisibility=hidden. When using dlopen() it seems that the loaded DSO
  # cannot see symbols in the executable which are hidden, even if the
  # executable is statically linked together...

  # XXX Remove this when v8 defaults x86_64 to native builds
  arch = ""
  if bld.env['DEST_CPU'] == 'x86_64':
    arch = "arch=x64"

  if variant == "default":
    mode = "release"
  else:
    mode = "debug"

  cmd_R = 'python "%s" -j %d -C "%s" -Y "%s" visibility=default mode=%s %s library=static snapshot=on'

  cmd = cmd_R % ( scons
                , Options.options.jobs
                , bld.srcnode.abspath(bld.env_of_name(variant))
                , v8dir_src
                , mode
                , arch
                )
  return cmd


def build_v8(bld):
  v8 = bld.new_task_gen(
    source        = 'deps/v8/SConstruct ' 
                  + bld.path.ant_glob('v8/include/*') 
                  + bld.path.ant_glob('v8/src/*'),
    target        = bld.env["staticlib_PATTERN"] % "v8",
    rule          = v8_cmd(bld, "default"),
    before        = "cxx",
    install_path  = None
  )
  v8.uselib = "EXECINFO"
  bld.env["CPPPATH_V8"] = "deps/v8/include"
  t = join(bld.srcnode.abspath(bld.env_of_name("default")), v8.target)
  bld.env_of_name('default').append_value("LINKFLAGS_V8", t)


  ### v8 debug
  if bld.env["USE_DEBUG"]:
    v8_debug = v8.clone("debug")
    v8_debug.rule   = v8_cmd(bld, "debug")
    v8_debug.target = bld.env["staticlib_PATTERN"] % "v8_g"
    v8_debug.uselib = "EXECINFO"
    t = join(bld.srcnode.abspath(bld.env_of_name("debug")), v8_debug.target)
    bld.env_of_name('debug').append_value("LINKFLAGS_V8", t)

  bld.install_files('${PREFIX}/include/node/', 'deps/v8/include/*.h')

def build(bld):
  Options.options.jobs=jobs
  print "DEST_OS: " + bld.env['DEST_OS']
  print "DEST_CPU: " + bld.env['DEST_CPU']
  print "Parallel Jobs: " + str(Options.options.jobs)

  if not bld.env["USE_SYSTEM"]:
    bld.add_subdirs('deps/libeio deps/libev deps/c-ares')
    build_v8(bld)
  else:
    bld.add_subdirs('deps/libeio')


  ### http_parser
  http_parser = bld.new_task_gen("cc")
  http_parser.source = "deps/http_parser/http_parser.c"
  http_parser.includes = "deps/http_parser/"
  http_parser.name = "http_parser"
  http_parser.target = "http_parser"
  http_parser.install_path = None
  if bld.env["USE_DEBUG"]:
    http_parser.clone("debug")

  ### src/native.cc
  def make_macros(loc, content):
    f = open(loc, 'w')
    f.write(content)
    f.close

  macros_loc_debug   = join(
     bld.srcnode.abspath(bld.env_of_name("debug")),
     "macros.py"
  )

  macros_loc_default = join(
    bld.srcnode.abspath(bld.env_of_name("default")),
    "macros.py"
  )

  make_macros(macros_loc_debug, "")  # leave debug(x) as is in debug build
  # replace debug(x) with nothing in release build
  make_macros(macros_loc_default, "macro debug(x) = ;\n")

  def javascript_in_c(task):
    env = task.env
    source = map(lambda x: x.srcpath(env), task.inputs)
    targets = map(lambda x: x.srcpath(env), task.outputs)
    source.append(macros_loc_default)
    js2c.JS2C(source, targets)

  def javascript_in_c_debug(task):
    env = task.env
    source = map(lambda x: x.srcpath(env), task.inputs)
    targets = map(lambda x: x.srcpath(env), task.outputs)
    source.append(macros_loc_debug)
    js2c.JS2C(source, targets)

  native_cc = bld.new_task_gen(
    source='src/node.js ' + bld.path.ant_glob('lib/*.js'),
    target="src/node_natives.h",
    before="cxx",
    install_path=None
  )

  # Add the rule /after/ cloning the debug
  # This is a work around for an error had in python 2.4.3 (I'll paste the
  # error that was had into the git commit meessage. git-blame to find out
  # where.)
  if bld.env["USE_DEBUG"]:
    native_cc_debug = native_cc.clone("debug")
    native_cc_debug.rule = javascript_in_c_debug

  native_cc.rule = javascript_in_c

  ### node lib
  node = bld.new_task_gen("cxx", "program")
  node.name         = "node"
  node.target       = "node"
  node.source = """
    src/node.cc
    src/node_buffer.cc
    src/node_http_parser.cc
    src/node_net.cc
    src/node_io_watcher.cc
    src/node_child_process.cc
    src/node_constants.cc
    src/node_cares.cc
    src/node_events.cc
    src/node_file.cc
    src/node_signal_watcher.cc
    src/node_stat_watcher.cc
    src/node_stdio.cc
    src/node_timer.cc
    src/node_script.cc
  """
  if bld.env["USE_OPENSSL"]:
    node.source += "src/node_crypto.cc"

  if not bld.env["USE_SYSTEM"]:
    node.includes = """
      src/ 
      deps/v8/include
      deps/libev
      deps/c-ares
      deps/libeio
      deps/http_parser
    """

    node.includes += ' deps/c-ares/' + bld.env['DEST_OS'] + '-' + bld.env['DEST_CPU']


    node.add_objects = 'cares ev eio http_parser'
    node.uselib_local = ''
    node.uselib = 'RT OPENSSL V8 EXECINFO DL KVM SOCKET NSL'
  else:
    node.includes = """
      src/
      deps/libeio
      deps/http_parser
    """
    node.add_objects = 'eio http_parser'
    node.uselib_local = 'eio'
    node.uselib = 'RT EV OPENSSL CARES V8 EXECINFO DL KVM SOCKET NSL'

  node.install_path = '${PREFIX}/lib'
  node.install_path = '${PREFIX}/bin'
  node.chmod = 0755

  def subflags(program):
    if os.path.exists(join(cwd, ".git")):
      actual_version=cmd_output("git describe").strip()
    else:
      actual_version=VERSION

    x = { 'CCFLAGS'   : " ".join(program.env["CCFLAGS"])
        , 'CPPFLAGS'  : " ".join(program.env["CPPFLAGS"])
        , 'LIBFLAGS'  : " ".join(program.env["LIBFLAGS"])
        , 'VERSION'   : actual_version

=== deps/http_parser/Makefile ===
OPT_DEBUG=-O0 -g -Wall -Wextra -Werror -I.
OPT_FAST=-O3 -DHTTP_PARSER_STRICT=0 -I.


test: test_g
	./test_g

test_g: http_parser_g.o test_g.o
	gcc $(OPT_DEBUG) http_parser_g.o test_g.o -o $@

test_g.o: test.c Makefile
	gcc $(OPT_DEBUG) -c test.c -o $@

test.o: test.c Makefile
	gcc $(OPT_FAST) -c test.c -o $@

http_parser_g.o: http_parser.c http_parser.h Makefile
	gcc $(OPT_DEBUG) -c http_parser.c -o $@

test-valgrind: test_g
	valgrind ./test_g

http_parser.o: http_parser.c http_parser.h Makefile
	gcc $(OPT_FAST) -c http_parser.c

test_fast: http_parser.o test.c
	gcc $(OPT_FAST) http_parser.o test.c -o $@

test-run-timed: test_fast
	while(true) do time ./test_fast > /dev/null; done


tags: http_parser.c http_parser.h test.c
	ctags $^

clean:
	rm -f *.o test test_fast test_g http_parser.tar tags

.PHONY: clean package test-run test-run-timed test-valgrind

=== deps/libeio/wscript ===
import Options

def set_options(opt):
  pass
  #opt.tool_options('compiler_cc')

def configure(conf):
  print "--- libeio ---"
  #conf.check_tool('compiler_cc')

  conf.check(lib='pthread', uselib_store='PTHREAD')
  conf.check_cc(lib="pthread", header_name="pthread.h", function_name="pthread_create", mandatory=True)
  conf.check_cc(lib="pthread", header_name="pthread.h", function_name="pthread_atfork", mandatory=True)

  conf.check_cc(msg="Checking for futimes(2)", define_name="HAVE_FUTIMES", fragment="""
    #include <sys/types.h>
    #include <sys/time.h>
    #include <utime.h>
    struct timeval tv[2];
    int res;
    int fd;
    int main(void)
    {
       res = futimes (fd, tv);
       return 0;
    }
  """)

  conf.check_cc(msg="Checking for readahead(2)", define_name="HAVE_READAHEAD", fragment="""
    #include <fcntl.h>
    int main(void)
    {
       int fd = 0;
       size_t count = 2;
       ssize_t res;
       res = readahead (fd, 0, count);
       return 0;
    }
  """)

  conf.check_cc(msg="Checking for fdatasync(2)", define_name="HAVE_FDATASYNC", fragment="""
    #include <unistd.h>
    int main(void)
    {
       int fd = 0;
       fdatasync (fd);
       return 0;
    }
  """)

  conf.check_cc(msg="Checking for pread(2) and pwrite(2)", define_name="HAVE_PREADWRITE", fragment="""
    #include <unistd.h>
    int main(void)
    {
       int fd = 0;
       size_t count = 1;
       char buf;
       off_t offset = 1;
       ssize_t res;
       res = pread (fd, &buf, count, offset);
       res = pwrite (fd, &buf, count, offset);
       return 0;
    }
  """)

  conf.check_cc(msg="Checking for sendfile(2)" , define_name="HAVE_SENDFILE" , fragment=""" 
    # include <sys/types.h>
    #if __linux
    # include <sys/sendfile.h>
    #elif __FreeBSD__ || defined(__APPLE__)
    # include <sys/socket.h>
    # include <sys/uio.h>
    #elif __hpux
    # include <sys/socket.h>
    #else
    # error unsupported architecture
    #endif
    int main(void)
    {
       int fd = 0;
       off_t offset = 1;
       size_t count = 2;
       ssize_t res;
    #if __linux
       res = sendfile (fd, fd, offset, count);
    #elif __FreeBSD__
       res = sendfile (fd, fd, offset, count, 0, &offset, 0);
    #elif __APPLE__
       res = sendfile (fd, fd, offset, &offset, 0, 0);
    #elif __hpux
       res = sendfile (fd, fd, offset, count, 0, 0);
    #endif
       return 0;
    }
  """)

  conf.env.append_value("CCFLAGS", "-D_GNU_SOURCE")
  conf.check_cc(msg="Checking for sync_file_range(2) ", fragment="""
    #include <fcntl.h>
    int main(void)
    {
       int fd = 0;
       off64_t offset = 1;
       off64_t nbytes = 1;
       unsigned int flags = SYNC_FILE_RANGE_WAIT_BEFORE|SYNC_FILE_RANGE_WRITE|SYNC_FILE_RANGE_WAIT_AFTER;
       ssize_t res;
       res = sync_file_range (fd, offset, nbytes, flags);
       return 0;
    }
  """, define_name="HAVE_SYNC_FILE_RANGE")

def build(bld):
  libeio = bld.new_task_gen("cc")
  libeio.source = "eio.c"
  libeio.target = 'eio'
  libeio.name = 'eio'
  libeio.includes = '. ../..'
  libeio.uselib = "PTHREAD"
  libeio.install_path = None
  if bld.env["USE_DEBUG"]:
    libeio.clone("debug");
  bld.install_files('${PREFIX}/include/node/', 'eio.h');

=== deps/v8/SConstruct ===
# Copyright 2010 the V8 project authors. All rights reserved.
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above
#       copyright notice, this list of conditions and the following
#       disclaimer in the documentation and/or other materials provided
#       with the distribution.
#     * Neither the name of Google Inc. nor the names of its
#       contributors may be used to endorse or promote products derived
#       from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

import platform
import re
import sys
import os
from os.path import join, dirname, abspath
from types import DictType, StringTypes
root_dir = dirname(File('SConstruct').rfile().abspath)
sys.path.append(join(root_dir, 'tools'))
import js2c, utils

# ANDROID_TOP is the top of the Android checkout, fetched from the environment
# variable 'TOP'.   You will also need to set the CXX, CC, AR and RANLIB
# environment variables to the cross-compiling tools.
ANDROID_TOP = os.environ.get('TOP')
if ANDROID_TOP is None:
  ANDROID_TOP=""

# ARM_TARGET_LIB is the path to the dynamic library to use on the target
# machine if cross-compiling to an arm machine. You will also need to set 
# the additional cross-compiling environment variables to the cross compiler.
ARM_TARGET_LIB = os.environ.get('ARM_TARGET_LIB')
if ARM_TARGET_LIB:
  ARM_LINK_FLAGS = ['-Wl,-rpath=' + ARM_TARGET_LIB + '/lib:' +
                     ARM_TARGET_LIB + '/usr/lib',
                    '-Wl,--dynamic-linker=' + ARM_TARGET_LIB +
                    '/lib/ld-linux.so.3']
else:
  ARM_LINK_FLAGS = []

# TODO: Sort these issues out properly but as a temporary solution for gcc 4.4
# on linux we need these compiler flags to avoid crashes in the v8 test suite
# and avoid dtoa.c strict aliasing issues
if os.environ.get('GCC_VERSION') == '44':
    GCC_EXTRA_CCFLAGS = ['-fno-tree-vrp', '-fno-strict-aliasing']
    GCC_DTOA_EXTRA_CCFLAGS = []
else:
    GCC_EXTRA_CCFLAGS = []
    GCC_DTOA_EXTRA_CCFLAGS = []

ANDROID_FLAGS = ['-march=armv7-a',
                 '-mtune=cortex-a8',
                 '-mfloat-abi=softfp',
                 '-mfpu=vfp',
                 '-fpic',
                 '-mthumb-interwork',
                 '-funwind-tables',
                 '-fstack-protector',
                 '-fno-short-enums',
                 '-fmessage-length=0',
                 '-finline-functions',
                 '-fno-inline-functions-called-once',
                 '-fgcse-after-reload',
                 '-frerun-cse-after-loop',
                 '-frename-registers',
                 '-fomit-frame-pointer',
                 '-fno-strict-aliasing',
                 '-finline-limit=64',
                 '-DCAN_USE_VFP_INSTRUCTIONS=1',
                 '-DCAN_USE_ARMV7_INSTRUCTIONS=1',
                 '-DCAN_USE_UNALIGNED_ACCESSES=1',
                 '-MD']

ANDROID_INCLUDES = [ANDROID_TOP + '/bionic/libc/arch-arm/include',
                    ANDROID_TOP + '/bionic/libc/include',
                    ANDROID_TOP + '/bionic/libstdc++/include',
                    ANDROID_TOP + '/bionic/libc/kernel/common',
                    ANDROID_TOP + '/bionic/libc/kernel/arch-arm',
                    ANDROID_TOP + '/bionic/libm/include',
                    ANDROID_TOP + '/bionic/libm/include/arch/arm',
                    ANDROID_TOP + '/bionic/libthread_db/include',
                    ANDROID_TOP + '/frameworks/base/include',
                    ANDROID_TOP + '/system/core/include']

ANDROID_LINKFLAGS = ['-nostdlib',
                     '-Bdynamic',
                     '-Wl,-T,' + ANDROID_TOP + '/build/core/armelf.x',
                     '-Wl,-dynamic-linker,/system/bin/linker',
                     '-Wl,--gc-sections',
                     '-Wl,-z,nocopyreloc',
                     '-Wl,-rpath-link=' + ANDROID_TOP + '/out/target/product/generic/obj/lib',
                     ANDROID_TOP + '/out/target/product/generic/obj/lib/crtbegin_dynamic.o',
                     ANDROID_TOP + '/prebuilt/linux-x86/toolchain/arm-eabi-4.4.0/lib/gcc/arm-eabi/4.4.0/interwork/libgcc.a',
                     ANDROID_TOP + '/out/target/product/generic/obj/lib/crtend_android.o'];

LIBRARY_FLAGS = {
  'all': {
    'CPPPATH': [join(root_dir, 'src')],
    'regexp:interpreted': {
      'CPPDEFINES': ['V8_INTERPRETED_REGEXP']
    },
    'mode:debug': {
      'CPPDEFINES': ['V8_ENABLE_CHECKS']
    },
    'vmstate:on': {
      'CPPDEFINES':   ['ENABLE_VMSTATE_TRACKING'],
    },
    'protectheap:on': {
      'CPPDEFINES':   ['ENABLE_VMSTATE_TRACKING', 'ENABLE_HEAP_PROTECTION'],
    },
    'profilingsupport:on': {
      'CPPDEFINES':   ['ENABLE_VMSTATE_TRACKING', 'ENABLE_LOGGING_AND_PROFILING'],
    },
    'debuggersupport:on': {
      'CPPDEFINES':   ['ENABLE_DEBUGGER_SUPPORT'],
    }
  },
  'gcc': {
    'all': {
      'CCFLAGS':      ['$DIALECTFLAGS', '$WARNINGFLAGS'],
      'CXXFLAGS':     ['$CCFLAGS', '-fno-rtti', '-fno-exceptions'],
    },
    'visibility:hidden': {
      # Use visibility=default to disable this.
      'CXXFLAGS':     ['-fvisibility=hidden']
    },
    'mode:debug': {
      'CCFLAGS':      ['-g', '-O0'],
      'CPPDEFINES':   ['ENABLE_DISASSEMBLER', 'DEBUG'],
      'os:android': {
        'CCFLAGS':    ['-mthumb']
      }
    },
    'mode:release': {
      'CCFLAGS':      ['-O3', '-fomit-frame-pointer', '-fdata-sections',
                       '-ffunction-sections'],
      'os:android': {
        'CCFLAGS':    ['-mthumb', '-Os'],
        'CPPDEFINES': ['SK_RELEASE', 'NDEBUG']
      }
    },
    'os:linux': {
      'CCFLAGS':      ['-ansi'] + GCC_EXTRA_CCFLAGS,
      'library:shared': {
        'CPPDEFINES': ['V8_SHARED'],
        'LIBS': ['pthread']
      }
    },
    'os:macos': {
      'CCFLAGS':      ['-ansi', '-mmacosx-version-min=10.4'],
      'library:shared': {
        'CPPDEFINES': ['V8_SHARED']
      }
    },
    'os:freebsd': {
      'CPPPATH' : ['/usr/local/include'],
      'LIBPATH' : ['/usr/local/lib'],
      'CCFLAGS':      ['-ansi'],
    },
    'os:openbsd': {
      'CPPPATH' : ['/usr/local/include'],
      'LIBPATH' : ['/usr/local/lib'],
      'CCFLAGS':      ['-ansi'],
    },
    'os:solaris': {
      # On Solaris, to get isinf, INFINITY, fpclassify and other macros one
      # needs to define __C99FEATURES__.
      'CPPDEFINES': ['__C99FEATURES__'],
      'CPPPATH' : ['/usr/local/include'],
      'LIBPATH' : ['/usr/local/lib'],
      'CCFLAGS':      ['-ansi'],
    },
    'os:win32': {
      'CCFLAGS':      ['-DWIN32'],
      'CXXFLAGS':     ['-DWIN32'],
    },
    'os:android': {
      'CPPDEFINES':   ['ANDROID', '__ARM_ARCH_5__', '__ARM_ARCH_5T__',
                       '__ARM_ARCH_5E__', '__ARM_ARCH_5TE__'],
      'CCFLAGS':      ANDROID_FLAGS,
      'WARNINGFLAGS': ['-Wall', '-Wno-unused', '-Werror=return-type',
                       '-Wstrict-aliasing=2'],
      'CPPPATH':      ANDROID_INCLUDES,
    },
    'arch:ia32': {
      'CPPDEFINES':   ['V8_TARGET_ARCH_IA32'],
      'CCFLAGS':      ['-m32'],
      'LINKFLAGS':    ['-m32']
    },
    'arch:arm': {
      'CPPDEFINES':   ['V8_TARGET_ARCH_ARM']
    },
    'simulator:arm': {
      'CCFLAGS':      ['-m32', '-DCAN_USE_UNALIGNED_ACCESSES=1'],
      'LINKFLAGS':    ['-m32']
    },
    'arch:mips': {
      'CPPDEFINES':   ['V8_TARGET_ARCH_MIPS'],
      'simulator:none': {
        'CCFLAGS':      ['-EL', '-mips32r2', '-Wa,-mips32r2', '-fno-inline'],
        'LDFLAGS':      ['-EL']
      }
    },
    'simulator:mips': {
      'CCFLAGS':      ['-m32'],
      'LINKFLAGS':    ['-m32']
    },
    'arch:x64': {
      'CPPDEFINES':   ['V8_TARGET_ARCH_X64'],
      'CCFLAGS':      ['-m64'],
      'LINKFLAGS':    ['-m64'],
    },
    'prof:oprofile': {
      'CPPDEFINES':   ['ENABLE_OPROFILE_AGENT']
    }
  },
  'msvc': {
    'all': {
      'CCFLAGS':      ['$DIALECTFLAGS', '$WARNINGFLAGS'],
      'CXXFLAGS':     ['$CCFLAGS', '/GR-', '/Gy'],
      'CPPDEFINES':   ['WIN32'],
      'LINKFLAGS':    ['/INCREMENTAL:NO', '/NXCOMPAT', '/IGNORE:4221'],
      'CCPDBFLAGS':   ['/Zi']
    },
    'verbose:off': {
      'DIALECTFLAGS': ['/nologo'],
      'ARFLAGS':      ['/NOLOGO']
    },
    'arch:ia32': {
      'CPPDEFINES':   ['V8_TARGET_ARCH_IA32', '_USE_32BIT_TIME_T'],
      'LINKFLAGS':    ['/MACHINE:X86'],
      'ARFLAGS':      ['/MACHINE:X86']
    },
    'arch:x64': {
      'CPPDEFINES':   ['V8_TARGET_ARCH_X64'],
      'LINKFLAGS':    ['/MACHINE:X64'],
      'ARFLAGS':      ['/MACHINE:X64']
    },
    'mode:debug': {
      'CCFLAGS':      ['/Od', '/Gm'],
      'CPPDEFINES':   ['_DEBUG', 'ENABLE_DISASSEMBLER', 'DEBUG'],
      'LINKFLAGS':    ['/DEBUG'],
      'msvcrt:static': {
        'CCFLAGS': ['/MTd']
      },
      'msvcrt:shared': {
        'CCFLAGS': ['/MDd']
      }
    },
    'mode:release': {
      'CCFLAGS':      ['/O2'],
      'LINKFLAGS':    ['/OPT:REF', '/OPT:ICF'],
      'msvcrt:static': {
        'CCFLAGS': ['/MT']
      },
      'msvcrt:shared': {
        'CCFLAGS': ['/MD']
      },
      'msvcltcg:on': {
        'CCFLAGS':      ['/GL'],
        'ARFLAGS':      ['/LTCG'],
        'pgo:off': {
          'LINKFLAGS':    ['/LTCG'],
        },
        'pgo:instrument': {
          'LINKFLAGS':    ['/LTCG:PGI']
        },
        'pgo:optimize': {
          'LINKFLAGS':    ['/LTCG:PGO']
        }
      }
    }
  }
}


V8_EXTRA_FLAGS = {
  'gcc': {
    'all': {
      'WARNINGFLAGS': ['-Wall',
                       '-W',
                       '-Wno-unused-parameter',
                       '-Wnon-virtual-dtor']
    },
    'os:win32': {
      'WARNINGFLAGS': ['-pedantic', '-Wno-long-long']
    },
    'os:linux': {
      'WARNINGFLAGS': ['-pedantic'],
      'library:shared': {
        'soname:on': {
          'LINKFLAGS': ['-Wl,-soname,${SONAME}']
        }
      }
    },
    'os:macos': {
      'WARNINGFLAGS': ['-pedantic']
    },
    'disassembler:on': {
      'CPPDEFINES':   ['ENABLE_DISASSEMBLER']
    }
  },
  'msvc': {
    'all': {
      'WARNINGFLAGS': ['/W3', '/WX', '/wd4355', '/wd4800']
    },
    'library:shared': {
      'CPPDEFINES': ['BUILDING_V8_SHARED'],
      'LIBS': ['winmm', 'ws2_32']
    },
    'arch:arm': {
      'CPPDEFINES':   ['V8_TARGET_ARCH_ARM'],
      # /wd4996 is to silence the warning about sscanf
      # used by the arm simulator.
      'WARNINGFLAGS': ['/wd4996']
    },
    'arch:mips': {
      'CPPDEFINES':   ['V8_TARGET_ARCH_MIPS'],
    },
    'disassembler:on': {
      'CPPDEFINES':   ['ENABLE_DISASSEMBLER']
    }
  }
}


MKSNAPSHOT_EXTRA_FLAGS = {
  'gcc': {
    'os:linux': {
      'LIBS': ['pthread'],
    },
    'os:macos': {
      'LIBS': ['pthread'],
    },
    'os:freebsd': {
      'LIBS': ['execinfo', 'pthread']
    },
    'os:solaris': {
      'LIBS': ['m', 'pthread', 'socket', 'nsl', 'rt'],
      'LINKFLAGS': ['-mt']
    },
    'os:openbsd': {
      'LIBS': ['execinfo', 'pthread']
    },
    'os:win32': {
      'LIBS': ['winmm', 'ws2_32'],
    },
  },
  'msvc': {
    'all': {

=== debian/changelog ===
nodejs (0.1.97-1build1) maverick; urgency=low

  * No changes upload for libv8-2.2.7 -> libv8-2.2.18 transition

 -- Fabrice Coutadeur <fabricesp@ubuntu.com>  Thu, 16 Sep 2010 05:32:58 +0200

nodejs (0.1.97-1) unstable; urgency=low

  * New upstream release

 -- Jérémy Lal <kapouer@melix.org>  Sun, 30 May 2010 23:14:24 +0200

nodejs (0.1.95-1) unstable; urgency=low

  * New upstream release

 -- Jérémy Lal <kapouer@melix.org>  Fri, 14 May 2010 02:05:25 +0200

nodejs (0.1.94-2) unstable; urgency=low

  * Drop dependencies on libgnutls-dev, libgpg-error-dev.
  * Modules path moved to /usr/lib/nodejs (without /modules), to
    follow more closely upstream practice.
  * node-repl is now in /usr/share/nodejs because it is
    simply a js script file ; nodejs-repl still in /usr/bin

 -- Jérémy Lal <kapouer@melix.org>  Tue, 11 May 2010 19:52:12 +0200

nodejs (0.1.94-1) unstable; urgency=low

  * New upstream release
  * API has changed and will be more stable with 0.2 release
  * Fix dependency on libv8. (Closes: #579044)
  * Switched from gnutls to libssl.

 -- Jérémy Lal <kapouer@melix.org>  Thu, 06 May 2010 23:19:12 +0200

nodejs (0.1.92-1) unstable; urgency=low

  * New upstream release
  * Switch from udns to c-ares.

 -- Jérémy Lal <kapouer@melix.org>  Sat, 24 Apr 2010 09:12:06 +0200

nodejs (0.1.33-3) unstable; urgency=low

  * Fix wrong use of binary-indep target in debian/rules.
    (Closes: #575383) 

 -- Jérémy Lal <kapouer@melix.org>  Mon, 05 Apr 2010 15:26:40 +0200

nodejs (0.1.33-2) unstable; urgency=low

  * Previous package was broken in some way. (Closes: #575383)

 -- Jérémy Lal <kapouer@melix.org>  Thu, 25 Mar 2010 12:24:06 +0100

nodejs (0.1.33-1) unstable; urgency=low

  * New upstream release. (Closes: #572023)
  * Debian package has the same license as upstream (MIT).
  * Include waf in source package and nodejs-dev package. (Closes: #571710)
  * Switch to dpkg-source 3.0 (quilt) format.
  * Place modules directory in usr/lib/nodejs/modules,
    and add it to nodejs module path. Documentation in README.Debian.
  * Architecture: any since the supported archs depends only on libv8.

 -- Jérémy Lal <kapouer@melix.org>  Mon, 22 Mar 2010 01:53:48 +0100

nodejs (0.1.27+dfsg-1) unstable; urgency=low

  * Initial release (Closes: #553514)

 -- Jérémy Lal <kapouer@melix.org>  Sun, 07 Feb 2010 01:16:07 +0100

=== debian/control ===
Source: nodejs
Section: web
Priority: extra
Maintainer: Jérémy Lal <kapouer@melix.org>
Uploaders: Dave Beckett <dajobe@debian.org>
Build-Depends: debhelper (>= 7), python, libev-dev (>= 3.9), libv8-dev (>= 2.2.7), scons (>= 1.2.0), libc-ares-dev (>= 1.7.1), binutils, libssl-dev (>= 0.9.8), pkg-config
Standards-Version: 3.8.4
Homepage: http://nodejs.org/
Vcs-Browser: http://git.debian.org/?p=collab-maint/nodejs.git
Vcs-Git: git://git.debian.org/git/collab-maint/nodejs.git

Package: nodejs-dev
Section: devel
Architecture: any
Depends: nodejs (= ${binary:Version}), ${misc:Depends}, python, libev-dev (>= 3.9), libv8-dev (>= 2.2.7), libc-ares-dev (>= 1.7.1), libssl-dev (>= 0.9.8)
Description: Development files for Node.js
 Node.js provides an event-based server-side javascript engine.
 .
 It is similar in design to and influenced by systems like
 Ruby's Event Machine or Python's Twisted.
 .
 Node.js takes the event model a bit further - it presents the event
 loop as a language construct instead of as a library.
 .
 This package is needed to build plugins.

Package: nodejs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, rlwrap
Description: Node.js event-based server-side javascript engine
 Node.js is similar in design to and influenced by systems like
 Ruby's Event Machine or Python's Twisted.
 .
 It takes the event model a bit further - it presents the event
 loop as a language construct instead of as a library.
 .
 Node.js is bundled with several useful libraries to handle server tasks :
 System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
 HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.

Package: nodejs-dbg
Section: debug
Architecture: any
Depends: ${misc:Depends}, nodejs (= ${binary:Version})
Suggests: libv8-dbg (>= 2.2.7)
Description: Node.js event-based server-side javascript engine (debug)
 Node.js is similar in design to and influenced by systems like
 Ruby's Event Machine or Python's Twisted.
 .
 It takes the event model a bit further - it presents the event
 loop as a language construct instead of as a library.
 .
 Node.js is bundled with several useful libraries to handle server tasks :
 System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
 HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.
 .
 This package contains the debugging symbols.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

config.status:
	dh_testdir
	PREFIX="/usr" ./configure --debug --system
	touch $@

build: build-stamp

build-stamp: config.status
	dh_testdir
	$(MAKE)

clean:
	rm -f node
	rm -f node_g
	rm -f doc/nodejs.1
	rm -f .lock-wscript
	dh_testdir
	dh_testroot
	rm -f build-stamp
	$(MAKE) clean || true
	# first make fails, and creates *.pyc files
	find . -name "*.pyc" -delete
	rm -rf build
	rm -f config.status
	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_prep  
	dh_installdirs
	# Rename man page to NODEJS
	# rename binaries to nodejs, nodejs-waf, nodejs-repl
	# escape single quotes at the start of lines, and false macros starting with a dot
	sed \
		-e 's/"NODE"/"NODEJS"/g' \
		-e "s/^'/\\\'/g" \
		-e "s/^\.\.\./ \\\.\\\.\\\./g" \
		-e "s/^\.\./ \\\.\\\./g" \
		-e "s/^\.node/\\\.node/g" \
		-e "s/\\\'node\\\'/\\\'nodejs\\\'/g" \
		-e 's/node\\-waf/nodejs\\-waf/g' \
		-e 's/node\\-repl/nodejs\\-repl/g' \
		-e 's/> node/> nodejs/g' \
		-e 's/node \\- evented/nodejs \\- evented/g' \
		doc/node.1 > doc/nodejs.1
	
	# Add here commands to install the package
	DESTDIR=$(CURDIR)/debian/nodejs $(MAKE) install
	# rename and install binaries in nodejs, nodejs-dbg
	mv $(CURDIR)/debian/nodejs/usr/bin/node $(CURDIR)/debian/nodejs/usr/bin/nodejs
	mv $(CURDIR)/debian/nodejs/usr/bin/node_g $(CURDIR)/debian/nodejs-dbg/usr/lib/debug/usr/bin/nodejs
	# headers for nodejs-dev
	mv $(CURDIR)/debian/nodejs/usr/include/node/* $(CURDIR)/debian/nodejs-dev/usr/include/nodejs/
	rm -rf $(CURDIR)/debian/nodejs/usr/include
	# waf for nodejs-dev
	mv $(CURDIR)/debian/nodejs/usr/bin/node-waf $(CURDIR)/debian/nodejs-dev/usr/bin/nodejs-waf
	mv $(CURDIR)/debian/nodejs/usr/share/nodejs/wafadmin $(CURDIR)/debian/nodejs-dev/usr/share/nodejs/
	# nodejs-repl (rlwrap version) for nodejs
	mv $(CURDIR)/debian/nodejs/usr/bin/node-repl $(CURDIR)/debian/nodejs/usr/share/nodejs/
	cp $(CURDIR)/debian/nodejs-repl $(CURDIR)/debian/nodejs/usr/bin/
	chmod 755 $(CURDIR)/debian/nodejs/usr/bin/nodejs-repl

# Build architecture-dependent files here.
binary-arch: install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installexamples
	dh_installman
	dh_link
	dh_strip --dbg-package=nodejs-dbg
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## nodejs 0.2.6

=== debian/changelog ===
nodejs (0.2.6-4ubuntu1) natty; urgency=low

  * debian/patches/2007_remove_internet_test.patch:
    - Remove test which requires internet connection

 -- Angel Abad <angelabad@ubuntu.com>  Tue, 22 Feb 2011 17:00:49 +0100

nodejs (0.2.6-4build1) natty; urgency=low

  * No-change rebuild against libv8-2.5.9.9

 -- Angel Abad <angelabad@ubuntu.com>  Tue, 22 Feb 2011 09:34:28 +0100

nodejs (0.2.6-4) unstable; urgency=low

  [ Jérémy Lal ]
  * Disable simple/test-buffer Buffer.unpack test that fails on ARM.
    The pack/unpack functions are deprecated, and not documented.

  [ Jonas Smedegaard ]
  * Drop done items from TODO.

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 07 Feb 2011 23:39:40 +0100

nodejs (0.2.6-3) experimental; urgency=low

  [ Jérémy Lal ]
  * Disable simple/test-dgram-multicast test that fails on sbuild.

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 25 Jan 2011 23:53:05 +0100

nodejs (0.2.6-2) experimental; urgency=low

  [ Jérémy Lal ]
  * Build-depends on libv8-2.5.9.9-2.
    (Closes: #610527, #607319, #605447, #597784)
  * Refactor patches, DEP-3 format.
  * Explain modules search paths in README.Debian.

  [ Jonas Smedegaard ]
  * Relax nodejs-dbg suggestion on libv8-dbg to be unversioned: already
    handled by library packages.

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 25 Jan 2011 22:11:05 +0100

nodejs (0.2.6-1) experimental; urgency=low

  [ Jérémy Lal ]
  * New upstream release.
  * nodejs is an alternative to js. (Closes: #597572)
  * Use upstream binary names for node and node-waf,
    conflicts with node package. (Closes: #597571)
  * Global modules search paths :
    /usr/local/lib/nodejs
    /usr/lib/nodejs
    Custom paths can be set through NODE_PATH.
    The reason is to support future npm package, giving higher
    priority to modules installed by npm as root.
  * Repackage using CDBS.  Enable regression testing.
  * Add a note about importing upstream tarball in README.source.
  * Update TODO

  [ Jonas Smedegaard ]
  * Add myself as uploader.
  * Limit watch file to stable releases.
  * Enable CDBS build-dependency autoresolving.
  * Tighten build-dependency on cdbs to versions properly supporting
    debhelper compat level 7.
  * Tighten build-dependency on debhelper to versions fully supporting
    compat level 7.
  * Build-depend on dh-buildinfo to include buildinfo hints with binary
    packages for easier troubleshooting.
  * Build-depend on curl: Needed for regression tests (testing on
    loopback, so should be Policy compliant).
  * Newline-delimit package relations for improved readability.
  * Add patch 2001 to skip TTY-needing regression test.

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 21 Jan 2011 21:00:24 +0100

nodejs (0.2.2-1) experimental; urgency=low

  * New upstream release

 -- Jérémy Lal <kapouer@melix.org>  Fri, 17 Sep 2010 21:27:40 +0200

nodejs (0.2.0-1) unstable; urgency=low

  * New upstream release

 -- Jérémy Lal <kapouer@melix.org>  Fri, 20 Aug 2010 11:49:04 +0200

nodejs (0.1.104-1) unstable; urgency=low

  * New upstream release. (Closes: #593088)

 -- Jérémy Lal <kapouer@melix.org>  Mon, 16 Aug 2010 07:07:09 +0200

nodejs (0.1.102-1) unstable; urgency=low

  * New upstream release

 -- Jérémy Lal <kapouer@melix.org>  Tue, 27 Jul 2010 08:29:40 +0200

nodejs (0.1.101-2) unstable; urgency=low

  * Build-Depends on bash-completion for dh_bash-completion 

 -- Jérémy Lal <kapouer@melix.org>  Wed, 21 Jul 2010 08:58:52 +0200

nodejs (0.1.101-1) unstable; urgency=low

  * New upstream release
  * Standards-Version 3.9.0
  * Move BSD license in debian/copyright
  * nodejs-waf now accepts NODE_PATH environment variable, which defines
    where to install compiled modules. Defaults to ~/.node_libraries.
  * nodejs-waf bash-completion snippet
  * API Manual registered with doc-base.
  * Depends on libv8-2.2.24

 -- Jérémy Lal <kapouer@melix.org>  Wed, 14 Jul 2010 13:52:07 +0200

nodejs (0.1.99-1) unstable; urgency=low

  * New upstream release
  * DNS module : MX support since c-ares 1.7.3
  * nodejs-repl is replaced by invoking nodejs without file argument,
    rlwrap is no more needed.
  * Full upstream author name in debian/copyright.

 -- Jérémy Lal <kapouer@melix.org>  Tue, 29 Jun 2010 08:25:13 +0200

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,24 @@
 Source: nodejs
 Section: web
 Priority: extra
-Maintainer: Jérémy Lal <kapouer@melix.org>
-Uploaders: Dave Beckett <dajobe@debian.org>
-Build-Depends: debhelper (>= 7), python, libev-dev (>= 3.9), libv8-dev (>= 2.2.7), scons (>= 1.2.0), libc-ares-dev (>= 1.7.1), binutils, libssl-dev (>= 0.9.8), pkg-config
-Standards-Version: 3.8.4
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Jérémy Lal <kapouer@melix.org>
+Uploaders: Dave Beckett <dajobe@debian.org>,
+ Jonas Smedegaard <dr@jones.dk>
+Build-Depends: cdbs (>= 0.4.85~),
+ debhelper (>= 7.0.1),
+ dh-buildinfo,
+ python,
+ libev-dev (>= 3.9),
+ libv8-dev (>= 2.5.9.9),
+ scons (>= 1.2.0),
+ libc-ares-dev (>= 1.7.3),
+ binutils,
+ libssl-dev (>= 0.9.8),
+ pkg-config,
+ bash-completion,
+ curl
+Standards-Version: 3.9.1
 Homepage: http://nodejs.org/
 Vcs-Browser: http://git.debian.org/?p=collab-maint/nodejs.git
 Vcs-Git: git://git.debian.org/git/collab-maint/nodejs.git
@@ -12,7 +26,13 @@
 Package: nodejs-dev
 Section: devel
 Architecture: any
-Depends: nodejs (= ${binary:Version}), ${misc:Depends}, python, libev-dev (>= 3.9), libv8-dev (>= 2.2.7), libc-ares-dev (>= 1.7.1), libssl-dev (>= 0.9.8)
+Depends: nodejs (= ${binary:Version}),
+ ${misc:Depends},
+ python,
+ libev-dev (>= 3.9),
+ libv8-dev (>= 2.5.9.9),
+ libc-ares-dev (>= 1.7.3),
+ libssl-dev (>= 0.9.8)
 Description: Development files for Node.js
  Node.js provides an event-based server-side javascript engine.
  .
@@ -26,7 +46,9 @@
 
 Package: nodejs
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, rlwrap
+Depends: ${shlibs:Depends},
+ ${misc:Depends}
+Conflicts: node
 Description: Node.js event-based server-side javascript engine
  Node.js is similar in design to and influenced by systems like
  Ruby's Event Machine or Python's Twisted.
@@ -41,8 +63,9 @@
 Package: nodejs-dbg
 Section: debug
 Architecture: any
-Depends: ${misc:Depends}, nodejs (= ${binary:Version})
-Suggests: libv8-dbg (>= 2.2.7)
+Depends: ${misc:Depends},
+ nodejs (= ${binary:Version})
+Suggests: libv8-dbg
 Description: Node.js event-based server-side javascript engine (debug)
  Node.js is similar in design to and influenced by systems like
  Ruby's Event Machine or Python's Twisted.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/upstream-tarball.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/autotools.mk

DEB_UPSTREAM_URL = http://nodejs.org/dist
DEB_UPSTREAM_TARBALL_BASENAME = node-v$(DEB_UPSTREAM_TARBALL_VERSION)
DEB_CONFIGURE_NORMAL_ARGS =
DEB_CONFIGURE_EXTRA_FLAGS = --debug --shared-v8 --shared-cares --shared-libev
DEB_CONFIGURE_SCRIPT_ENV += PREFIX="/usr"
DEB_DESTDIR = $(CURDIR)/debian/nodejs
DEB_MAKE_CLEAN_TARGET = clean
DEB_MAKE_CHECK_TARGET = test

# ignore upstream shipped backup files
DEB_CLEAN_EXCLUDE = deps/v8/src/SConscript.orig deps/v8/src/platform.h.orig

# remove links to binaries
clean::
	rm -f node
	rm -f node_g

# waf files
clean::
	rm -f .lock-wscript
	rm -rf build

# make test creates some files and folders
clean::
	rm -f test/fixtures/hello.txt
	rm -f test/fixtures/cycles/folder/cycles
	rm -rf test/tmp

# first make fails, and creates *.pyc files
clean::
	find . -name "*.pyc" -delete

# don't install node-repl
install/nodejs::	
	rm -f $(CURDIR)/debian/nodejs/usr/bin/node-repl

# rename and install binaries in nodejs-dbg
install/nodejs-dbg::
	mv $(CURDIR)/debian/nodejs/usr/bin/node_g $(CURDIR)/debian/nodejs-dbg/usr/lib/debug/usr/bin/node

# we have completion for nodejs-waf
install/nodejs-dev::
	dh_bash-completion

# headers for nodejs-dev
install/nodejs-dev::
	mv $(CURDIR)/debian/nodejs/usr/include/node/* $(CURDIR)/debian/nodejs-dev/usr/include/nodejs/
	rm -rf $(CURDIR)/debian/nodejs/usr/include

# waf for nodejs-dev
install/nodejs-dev::
	mv $(CURDIR)/debian/nodejs/usr/bin/node-waf $(CURDIR)/debian/nodejs-dev/usr/bin/
	mv $(CURDIR)/debian/nodejs/usr/share/nodejs/wafadmin $(CURDIR)/debian/nodejs-dev/usr/share/nodejs/

=== debian/watch ===
version=3
http://nodejs.org/dist/node-v(\d+\.[02468]\..*).tar.gz debian uupdate
